/***************************************************************************
 *   Copyright (C) 2007 by Dr. Feynman                                     *
 *   dr@feynman.com                                                        *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>

#include "../src/feynman_win32.h"

#include "../src/feynman.h"

int feynman_parse_config(char *str, char *username, char *password, char *hostname, int *port)
{
    return sscanf(str, "feynman://%[^:]:%[^@]@%[^:]:%d", username, password, hostname, port);
}

char *certificate = "test.pem";
int card_id = -1;

int get_dcw(void *args, t_feynman_ecm *ecm)
{
    int i;
    feynman_logging(FEYNMAN_LOGMODE_ALL, "[ Test client ] Got dcw (via callback) for session %d (status: %d): ", ecm->session, ecm->decrypt_status);
    for(i=0; i<ecm->dcw_len; i++)
    {
        printf("%02X ", ecm->dcw[i]);
    }
    printf("\n");

    card_id = ecm->card_id;

    return FEYNMAN_STATUS_OK;
}

/*
int get_dcw(void *args, t_feynman_ecm *ecm)
{
    struct running_service *service = (struct running_service *)args;

    if(ecm->decrypt_status == FEYNMAN_ECMSTATUS_DECRYPT_OK)
    {
        write_control_words_io(service, byte *ecm->dcw);
    }
    return FEYNMAN_STATUS_OK;
}
*/

void test_ecm(t_feynman_remote_server *server)
{
    unsigned char ecm[0x4f];
    int ecm_len = 0x30;
    unsigned char emm[0x4f];
    int emm_len = 0x30;
    unsigned char dcw[0x10];
    int session;

    usleep(1000000);

    memset(emm, 10, emm_len);
//     feynman_send_server_emm(server, 0x0b00, 0x00000000, 0x00001234, emm, emm_len); //GA
//     feynman_send_server_emm(server, 0x0b00, 0x00000000, 0x00123456, emm, emm_len); //SA
//     feynman_send_server_emm(server, 0x0b00, 0x00000000, 0x12345601, emm, emm_len); //UA

	
    session = 1;
	card_id = -1;
	//memset(ecm, 10, ecm_len);
    //feynman_send_server_ecm(server, session, card_id, 0x0b00, 0x00000000, 0x8899, ecm, ecm_len);
    //card_id = feynman_dcw_dummy_callback(server, session, dcw, 5000);
    while(1)
    {
		int card_id_ok = 0;
		
send_ecm:

        memset(ecm, session, ecm_len);
        card_id_ok = feynman_send_server_ecm(server, session, card_id,  0x0b00, 0x00000000, 0x8899, ecm, ecm_len);
		
        if(!server->dcw_callback)
        {
            unsigned char dcw[0x10];
            card_id = feynman_dcw_dummy_callback(server, session, dcw, 5000);
        }
		
        session++;

		if(card_id_ok && card_id<0) goto send_ecm; //ecm was only sent to one server, try again to all cards
			
        usleep(2000000);
    }
}

int main(int argc, char *argv[])
{
    t_feynman_remote_server *server = NULL;


    char username[255], password[255], hostname[255];
    int port = 0;

    feynman_parse_config("feynman://test1:password@192.168.0.100:55555", username, password, hostname, &port);
    server = feynman_add_remote_server(NULL);
    feynman_set_remote_server_username(server, username);
    feynman_set_remote_server_password(server, password);
    feynman_set_remote_server_hostname(server, hostname);
    server->port = port;

    printf("server: feynman://%s:%s@%s:%d\n", username, password, hostname, port);
    feynman_set_remote_server_dcw_callback(server, NULL);
    server->dcw_callback_args = NULL;

#ifdef HAVE_SSL
    feynman_init_remote_server_ssl(server, certificate, certificate);
#else
    feynman_init_remote_server(server);
#endif

    test_ecm(server);
    while(1)
    {
        usleep(2000000);
    }
    return 0;
}
